ANIMATION* initAnimation(ANIMATION* myAnim, ENTITY* tempMy, var anim_speed) {
	var animation_speed;
	animation_speed = anim_speed;
	
	// to make ent_blend work properly (it only blends "my")
	my = tempMy;
	
	while(my.skill2 > 0) { // as long as character is still alive
		// if new frame, start blending
		if (myAnim.animblend != blend && myAnim.blendframe != nullframe) { myAnim.animate2 = 0; myAnim.animblend = blend; }
		
		if (myAnim.animblend == blend) {
			// blend previous and current frames together, except for attacks..!
			if (myAnim.currentframe == stand) { ent_animate(my, "stand", myAnim.animate, ANM_CYCLE); }
			if (myAnim.currentframe == move) { ent_animate(my, "run", myAnim.animate, ANM_CYCLE); }
			if (myAnim.currentframe == block) { ent_animate(my, "block", myAnim.animate, ANM_CYCLE); }
			if (myAnim.currentframe == jump) { ent_animate(my, "jump", myAnim.animate, ANM_CYCLE); }
			if (myAnim.currentframe == jumpkick) { ent_animate(my, "doublekick", myAnim.animate, ANM_CYCLE); }
			
// check to see if player was attacking, if so, DONT blend (makes animations look awfull!)
//			if (myAnim.currentframe == punch) { myAnim.animate2 = 100; }
//			if (myAnim.currentframe == doublepunch) { myAnim.animate2 = 100; }
//			if (myAnim.currentframe == kick) { myAnim.animate2 = 100; }
//			if (myAnim.currentframe == doublekick) { myAnim.animate2 = 100; }
			
			if (myAnim.blendframe == stand) { ent_blend("stand", 0, myAnim.animate2); }
			if (myAnim.blendframe == move) { ent_blend("run", 0, myAnim.animate2); }
			if (myAnim.blendframe == block) { ent_blend("block", 0, myAnim.animate2); }
			if (myAnim.blendframe == jump) { ent_blend("jump", 0, myAnim.animate2); }
			if (myAnim.blendframe == jumpkick) { ent_blend("doublekick", 0, myAnim.animate2); }
			if (myAnim.blendframe == punch) { ent_blend("punch", 0, myAnim.animate2); }
			if (myAnim.blendframe == doublepunch) { ent_blend("doublepunch", 0, myAnim.animate2); }
			if (myAnim.blendframe == kick) { ent_blend("kick", 0, myAnim.animate2); }
			if (myAnim.blendframe == doublekick) { ent_blend("doublekick", 0, myAnim.animate2); }
			
			myAnim.animate2 += 45 * time_step;
			
			if (myAnim.animate2 >= 100) {
				myAnim.animate = 0;
				myAnim.animblend = myAnim.blendframe;
				myAnim.blendframe = nullframe;
			}
		}
		
		// animations
		if (myAnim.animblend == stand) {
			ent_animate(my, "Stand", myAnim.animate, ANM_CYCLE);
			myAnim.animate += animation_speed * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = stand;
		}
		
		if (myAnim.animblend == move) {
			ent_animate(my, "run", myAnim.animate, ANM_CYCLE);
			myAnim.animate += animation_speed * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = move;
		}
		
		if (myAnim.animblend == block) {
			ent_animate(my, "block", myAnim.animate, ANM_CYCLE);
			myAnim.animate += animation_speed * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = block;
		}
		
		if (myAnim.animblend == jump) {
			ent_animate(my, "jump", myAnim.animate, ANM_CYCLE);
			myAnim.animate += animation_speed * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = jump;
		}
		
		if (myAnim.animblend == jumpkick) {
			ent_animate(my, "doublekick", myAnim.animate, ANM_CYCLE);
			myAnim.animate += animation_speed * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = jumpkick;
		}
		
		if (myAnim.animblend == punch) {
			ent_animate(my, "punch", myAnim.animate, 0);
			myAnim.animate += (animation_speed*2) * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = punch;
		}
		
		if (myAnim.animblend == doublepunch) {
			ent_animate(my, "doublepunch", myAnim.animate, 0);
			myAnim.animate += (animation_speed*2) * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = doublepunch;
		}
		
		if (myAnim.animblend == kick) {
			ent_animate(my, "kick", myAnim.animate, 0);
			myAnim.animate += (animation_speed*2) * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = kick;
		}
		
		if (myAnim.animblend == doublekick) {
			ent_animate(my, "doublekick", myAnim.animate, 0);
			myAnim.animate += (animation_speed*2) * time_step;
			myAnim.animate %= 100;
			myAnim.currentframe = doublekick;
		}
		
		wait(1);
	}
}